//
//  Wavefront Obj`̃t@C̓ǂ݂݃C^[tFCX
//         by g0307 2006.10.9
//

#ifndef _S_OBJLOADER_
#define _S_OBJLOADER_	1

#include "s_triangle.h"

struct rgb_image {
	gray_t r;
	gray_t g;
	gray_t b;
	/*
	gray_t x;
	gray_t y;
	gray_t z;
	*/
	CString name;
};
// ގǗCu
class material_lib {

public:
	void build_albedo_LUT(FLOAT eta, FLOAT *lut);

	FLOAT find_root_Rd(FLOAT A, FLOAT rd, FLOAT epsiron);
	bool find_root_Rd_divide(FLOAT & a, FLOAT &b, FLOAT & aRd, FLOAT &bRd, FLOAT & rd, FLOAT A, FLOAT epsiron);

	void tran2albedo(const gray_t &in, gray_t &out, FLOAT eta, FLOAT *lut);
	void fill_normal(gray_t & img, int mask);
	void init_normalmap(gray_t & nx, gray_t & ny, gray_t & nz, int nw, int nh);
	rgb_image * load_texture_image(LPSTR filename);
	rgb_image * load_bump_image(LPSTR filename);
	material_lib();
	Material * get_material(LPSTR mat_name);
	void load_materials(LPSTR filename);
	materials_t				materials;
	std::vector<CString>	matnames;
	Material		default_matrial;

	// eNX`摜
	rgb_image		tex_images[100];
	rgb_image		bump_images[100];
	int				tex_num;
	int				bump_num;
	FLOAT LUT[255];

//	std::vector<rgb_image * >	tex_images;
};
// bVIuWFNg
class mesh_obj {

};

class obj_loader {

#define OBJ_INDEX_POLYGON 0
#define OBJ_INDEX_UV	  1
#define OBJ_INDEX_NORMAL  2
public:
	bool get_line(CString & str, DWORD & id, int type);
	void write_normalmap(LPSTR filename, gray_t &nx, gray_t &ny, gray_t &nz);

	void SetMinMax(D3DXVECTOR2 pt1, D3DXVECTOR2 pt2, D3DXVECTOR2 gMinMaxTable[]);
	void draw_trianlge_normal(CDC *pDC,
		gray_t & map_nx, gray_t & map_ny, gray_t & map_nz,
		int map_w, int map_h,
		const D3DXVECTOR3 & x1, const D3DXVECTOR3 & x2, const D3DXVECTOR3 & x3, 
		const D3DXVECTOR2 & uv1, const D3DXVECTOR2 & uv2, const D3DXVECTOR2 & uv3, 
		const D3DXVECTOR3 & n1, const D3DXVECTOR3 & n2, const D3DXVECTOR3 & n3
		);
	load_obj();
	bool get_indexes_from_str(CString & p1, CString &p2, CString & p3, DWORD & id1, DWORD & id2, DWORD & id3, DWORD type);
	void load_obj(CDC *pDC, LPSTR filename, ptriangles_t & ptrianlges);
	material_lib mat_lib;
	int triangle_num;

};

#endif


