//
//
//  eNXgt@Cǂݍ݃C^[tFCX
//			2006/10/19 by g0307
//

#ifndef _S_TXTLOADER_
#define _S_TXTLOADER_	1

#include "s_triangle.h"
#include "camera.h"
#include <direct.h>

class txt_loader 
{
private:
	std::ifstream *str;
public:

	int str_num;
	CString title, data[1024];

	txt_loader()
	{
		str = NULL;
		init();
	}
	txt_loader(LPSTR filename)
	{
		str = NULL;
		init();
		open(filename);
	};
	~txt_loader(){
		if(str){
			str->close();
			delete str;
			str = NULL;
		};
	};

	bool open(LPSTR filename){
		
		if(str == NULL){
			str = new std::ifstream;
		} else {
			delete str;
			str = new std::ifstream;
		};
		if(str->is_open())
			str->close();

		str->open(filename);

		if(!str->is_open())
			return false;

		return true;
	};


	void ch_dir(LPSTR filename){
		// JgfBNg܊JĂfBNgɈړ
		_getcwd(olddir, 1024);
		char filepath[256];
		memset(filepath, 0, 255);
		memcpy(filepath, filename, 256);
		for(int c = 255; c >= 0 ; c--)
			if(filepath[c] == '/' || filepath[c] == '\\'){
				filepath[c] = 0;
				break;
			};
		_chdir(filepath);
	};
	void rt_dir(){
			_chdir(olddir);
	};
	void init()
	{

		if(str){
			delete str;
			str = NULL;
		};
		int i;
		title = CString::CString(1024);
		for(i = 0; i < 1024; i++)
			data[i] = CString::CString(1024);

	};

	//
	//  PsǂݍŁAXy[XƂɋ؂
	//
	CString get_line(){

		char buf[1024];
		char word[1024];

		if(str->eof())
			return "EOF";

		str->getline(buf, 1024, '\n');
		int c = 0, n = 0;
		bool fWord = false;

		title = "";
		str_num = 0;
		while(buf[c] != '\n' && buf[c] != 0 && c < 1024){
			
			if(buf[c] == '#')
				return title;
			if(buf[c] == ' ' || buf[c] == '\t'){
				if(fWord){
					word[n] = 0;
					if(str_num == 0){
						title = word;
					} else {
						data[str_num-1] = word;
					};
					n = 0;
					str_num++;
					fWord = false;
				};
			} else {
				word[n++] = buf[c];
				fWord = true;
			};
			c++;
		};
		
		if(fWord){
			word[n] = 0;
			if(str_num == 0){
				title = word;
			} else {
				data[str_num-1] = word;
			};
			n = 0;
			str_num++;
			fWord = false;
		};

		return title;

	};

	char olddir[2048];



};

//*************************************************************
// }eAǗNX
//*************************************************************
struct mat_rgb_image {
	gray_t r;
	gray_t g;
	gray_t b;
	CString name;
};

class material_library : public txt_loader {
public:

	material_library(){
		init();
	};
	void init(){
		bump_num = tex_num = mat_num = 0;
		// ftHgގ
		default_matrial.gen_diffuse_material((Texture *) new Texture(D3DXVECTOR3(0.7f, 0.7f, 0.7f)));
	};
	
	//
	//  t@C̓ǂݍ
	//
	void load_materials(LPSTR filename){
		
		// t@Cǂݍ
		if(!open(filename))
			return;
		
		Material tmp_mat, *cur_mat = &default_matrial;
		int mat_index = mat_num;
		int i, n;
		FLOAT R, G, B;
		CString texture_file(1024), bump_file(1024), mat_name(1024), ret;
		
		// t@Cǂݍ
		while( (ret = get_line()) != "EOF"){
			
			// Psǂ
			if(ret == "newmtl"){
				// Vގǉ
				cur_mat = get_material(data[0].GetBuffer(1024));
				if(cur_mat == &default_matrial){
					mat_name = data[0];
					matnames[mat_index] = mat_name;
					cur_mat = &materials[mat_index];
					// @obt@m
					mat_index++;
					mat_num++;
				}
			} else if(ret == "Kd"){
				// diffusel
				R = atof(data[0]);
				G = atof(data[1]);
				B = atof(data[2]);
				if(cur_mat != &default_matrial)
				cur_mat->gen_diffuse_material((Texture *) new Texture(D3DXVECTOR3(R, G, B)));
			} else if(ret == "Ke"){
				// G~bgl
				if(cur_mat != &default_matrial){
				cur_mat->emittance = atof(data[0]);
				cur_mat->type = LIGHT_MATERIAL;
				}
			} else if(ret == "Ks"){
				// specularl
				R = atof(data[0]);
				G = atof(data[1]);
				B = atof(data[2]);
				if(cur_mat != &default_matrial)
				cur_mat->set_specular(D3DXVECTOR3(R, G, B));
			} else if(ret == "sigma_a"){
				// diffusel
				R = atof(data[0]);
				G = atof(data[1]);
				B = atof(data[2]);
				if(cur_mat != &default_matrial)
				cur_mat->sigma_a = D3DXVECTOR3(R, G, B);
			} else if(ret == "sigma_s"){
				// diffusel
				R = atof(data[0]);
				G = atof(data[1]);
				B = atof(data[2]);
				if(cur_mat != &default_matrial)
				cur_mat->sigma_s = D3DXVECTOR3(R, G, B);
			} else if(ret == "refraction"){
				// ܗ
				if(cur_mat != &default_matrial){
					FLOAT eta = atof(data[0]);
					cur_mat->eta = eta;
					if(eta > 0){
						cur_mat->type = DIFFUSE_SPECULAR;
					} else {
						cur_mat->type = REFRACT_SPECULAR;
					};
				};//fi
			} else if(ret == "map_Kd"){
				// eNX`̓ǂݍ
				if(cur_mat != &default_matrial){
				mat_rgb_image *pimg = load_texture_image(data[0].GetBuffer(1024));
				if(pimg){
					cur_mat->R->init_texture(&pimg->r, &pimg->g, &pimg->b, data[0].GetBuffer(1024));
					cur_mat->fTexture = true;
				};
				}
			} else if(title == "map_Bump"){
				if(cur_mat != &default_matrial){
				// ov}bv̓ǂݍ
				bump_file = data[0].GetBuffer(1024);
				mat_rgb_image *pimg = load_bump_image(data[0].GetBuffer(1024));
				if(pimg)
					cur_mat->R->init_bump(&pimg->g);
				}
			} else if(title == "sss"){
				if(cur_mat != &default_matrial){
				cur_mat->type = SSS_MATERIAL;
				cur_mat->build_sss_LUT();
				};
			};
			
		};
		
	}
	//****************************************************
	//	 摜eNX`ǂݍ
	//****************************************************
	mat_rgb_image * load_texture_image(LPSTR filename)
	{
		// ɓ摜ǂݍłȂ炻̃|C^Ԃ
		int i;
		for(i = 0; i < tex_num; i++){
			if(tex_images[i].name == filename)
				return &tex_images[i];
		};// i
		
		CDIB dib;
		if(!dib.read(NULL, filename))
			return NULL;
		
		mat_rgb_image *ref = &tex_images[tex_num];
		gray_t r, g, b;

		dib.decompose3(ref->r, ref->g, ref->b);
	
		//		build_albedo_LUT(1.3, LUT);
		ref->name = filename;
		tex_num++;
		
		return ref;
	}
	
	//
	//  摜eNX`ǂݍ
	//
	mat_rgb_image * load_bump_image(LPSTR filename)
	{
		// ɓ摜ǂݍłȂ炻̃|C^Ԃ
		int i;
		for(i = 0; i < bump_num; i++){
			if(bump_images[i].name == filename)
				return &bump_images[i];
		};// i
		
		CDIB dib;
		if(!dib.read(NULL, filename))
			return NULL;
		
		mat_rgb_image *ref = &bump_images[bump_num];
		dib.decompose3(ref->g, ref->g, ref->g);
		ref->name = filename;
		bump_num++;
		
		return ref;
	}

	//
	//  L[ɊւގԂ
	//
	Material * get_material(LPSTR mat_name)
	{
		int i;
		
		for(i = 0; i < mat_num; i++){
			if(matnames[i] == mat_name)
				return &materials[i];
		};
		//ȂƂ̓ftHgގԂ
		return &default_matrial;
	}

	// eNX`摜
	mat_rgb_image		tex_images[100];
	mat_rgb_image		bump_images[100];
	int					tex_num;
	int					bump_num;
	//
	Material				materials[100];
	int						mat_num;
	CString					matnames[100];
	Material				default_matrial;

};
//*************************************************************
// IuWFNg[_(wavefront`)
//*************************************************************
class object_loader : public txt_loader
{
public:

#define OBJ_INDEX_POLYGON 0
#define OBJ_INDEX_UV	  1
#define OBJ_INDEX_NORMAL  2
	
	material_library mat_lib;
	int triangle_num;
	
	//***************************************************************
	//  wavefront`.objt@C̓ǂݍ
	//***************************************************************
	int load_object(
		LPSTR filename, 
		D3DXVECTOR3 pos, D3DXVECTOR3 e1, D3DXVECTOR3 e2, D3DXVECTOR3 e3,
		ptriangles_t & ptrianlges){
		

		triangle_num = 0;
		
		FLOAT x, y, z, u[3], v[3], nx[3], ny[3], nz[3];
		DWORD pi1, pi2, pi3;
		DWORD ui1, ui2, ui3;
		DWORD ni1, ni2, ni3;
		Material * pCurrentMat = &mat_lib.default_matrial;
		
		std::vector<D3DXVECTOR3> Vertexes;   // _W
		std::vector<D3DXVECTOR3> Normals;    // @xNg
		std::vector<D3DXVECTOR2> UVs;		 // UVW			
		Vertexes.clear();
		Normals.clear();
		UVs.clear();
		// t@Cǂݍ
		if(!open(filename))
			return 0;
		
		ch_dir(filename);

		CString ret;
		
		while( (ret = get_line()) != "EOF"){
			
			if(ret == "v"){
				// _Wl
				x =  atof(data[0]);
				y = -atof(data[1]);
				z = -atof(data[2]);
				D3DXVECTOR3 v = pos + x * e1 + y * e2 + z * e3;
				Vertexes.push_back(v);
			} else if(ret == "vt"){
				// UVWl
				x = atof(data[0]);
				y = atof(data[1]);
				UVs.push_back(D3DXVECTOR2(x, y));
			} else if(ret == "vn"){
				// @xNg
				x =  atof(data[0]);
				y = -atof(data[1]);
				z = -atof(data[2]);
				D3DXVECTOR3 n = x * e1 + y * e2 + z * e3;
				D3DXVec3Normalize(&n, &n);
				Normals.push_back(n);		
			} else if(ret == "f" && pCurrentMat->R->rgb.x >= 0){
				for(int n = 0; n < 2 && data[n + 2] != ""; n++){
					// |S
					pi1 = pi2 = pi3 = -1;
					get_indexes_from_str(data[0], data[n + 1], data[n + 2], pi1, pi2, pi3, OBJ_INDEX_POLYGON);
					// UVl
					get_indexes_from_str(data[0], data[n + 1], data[n + 2], ui1, ui2, ui3, OBJ_INDEX_UV);
					// @
					get_indexes_from_str(data[0], data[n + 1], data[n + 2], ni1, ni2, ni3, OBJ_INDEX_NORMAL);
					//
					int vs = Vertexes.size();
					if( !(pi1 >= 0 && pi1 < vs &&
						pi2 >= 0 && pi2 < vs &&
						pi3 >= 0 && pi3 < vs))
						continue;
						
					D3DXVECTOR3 dp1 = Vertexes[pi1]  - Vertexes[pi2] ;
					D3DXVECTOR3 dp2 = Vertexes[pi1]  - Vertexes[pi3] ;
					FLOAT d1 = D3DXVec3Dot(&dp1, &dp1);
					FLOAT d2 = D3DXVec3Dot(&dp2, &dp2);
					// |S̍쐬
					if( (d1 < 10.0f && d2 < 10.0f) || vs < 100){
						if(ui1 != -1 && ni1 != -1){
							ptrianlges.push_back(new Triangle(
								Vertexes[pi1], 
								Vertexes[pi2],
								Vertexes[pi3],
								UVs[ui1],
								UVs[ui2],
								UVs[ui3],
								Normals[ni1],
								Normals[ni2],
								Normals[ni3],
								pCurrentMat));
						} else if(ni1 != -1){
							ptrianlges.push_back(new Triangle(
								Vertexes[pi1], 
								Vertexes[pi2],
								Vertexes[pi3],
								Normals[ni1],
								Normals[ni2],
								Normals[ni3],
								pCurrentMat));
						} else if(ui1 != -1){
							ptrianlges.push_back(new Triangle(
								Vertexes[pi1], 
								Vertexes[pi2],
								Vertexes[pi3],
								UVs[ui1],
								UVs[ui2],
								UVs[ui3],
								pCurrentMat));
						};
						triangle_num++;					
					};//fi 
				}			
			} else if(title == "usemtl"){
				// ގ̕ύX
//				pCurrentMat = mat_lib.get_material("m1");
				pCurrentMat = mat_lib.get_material(data[0].GetBuffer(1024));
			} else if(title == "mtllib"){
				// ގCu̓ǂݍ
				mat_lib.load_materials(data[0].GetBuffer(1024));
			};
			
		};//while

		rt_dir();

	};
	bool get_indexes_from_str(CString &p1, CString &p2, CString &p3, DWORD &id1, DWORD &id2, DWORD &id3, DWORD type)
	{
		
		DWORD d[3] = {-1, -1, -1}, du;
		
		if(!get_line_slash(p1, id1, type))
			return false;
		
		get_line_slash(p2, id2, type);
		get_line_slash(p3, id3, type);
		
		id1--;
		id2--;
		id3--;
		return true;
	}
	
	bool get_line_slash(CString &str, DWORD &id, int type)
	{
		
		char line[1024];
		memcpy(line, str.GetBuffer(1024), 1024);
		int i;
		DWORD d;
		
		id = -1;
		bool fNoUV = false;
		for(i = 0; i < 1000;i++){
			if(line[i] == '/' && line[i+1] == '/'){
				fNoUV = true;
			};
			if(line[i] == '/') line[i] = ' ';
		};//i
		
		if(type == 0){
			sscanf(line, "%d", &id);
		} else if(type == 1 && !fNoUV){
			sscanf(line, "%d %d", &d, &id);
		} else if(type == 2){
			if(fNoUV)
				sscanf(line, "%d %d", &d, &id);
			else
				sscanf(line, "%d %d %d", &d, &d, &id);
		};
		
		if(id == -1)
			return false;
		
		return true;
		
	}
	


};

//*************************************************************
//  V[[_
//*************************************************************
class scene_loader : public txt_loader
{
public:

	D3DXVECTOR3 pos, e1, e2, e3;
	CString file;
	FLOAT scale;

	D3DXMATRIX R, Ry, Rx, Rz;

	int mode;
#define MODE_LIGHT_READ		1
#define MODE_OBJECT_READ	2

	object_loader m_objloader;

	void load_scene(LPSTR filename, ptriangles_t & ptrianlges, ptriangles_t & lights, camera & cam)
	{
		open(filename);
		CString ret;
		FLOAT x, y, z;
		// ]s쐬
		D3DXMatrixIdentity(&Rx);
		D3DXMatrixIdentity(&Ry);
		D3DXMatrixIdentity(&Rz);

		while( (ret = get_line()) != "EOF"){
			ret.MakeLower();
			//Jʒu
			if(ret == "camera_pos"){
				cam.pos.x = atof(data[0]);
				cam.pos.y = atof(data[1]);
				cam.pos.z = atof(data[2]);
			} else if(ret == "look_at"){
				//ʒu
				cam.look_at.x = atof(data[0]);
				cam.look_at.y = atof(data[1]);
				cam.look_at.z = atof(data[2]);
			} else if(ret == "focus"){
				//tH[JX
				cam.Focus = atof(data[0]);
			} if(ret == "size"){
				cam.w = atof(data[0]);
				cam.h = atof(data[1]);
			}  else if(ret == "light"){
				mode = MODE_LIGHT_READ;
				//ǂݍ
				file = data[0];
				file.Remove('"');
				scale = 1.0;
				pos = D3DXVECTOR3(0.0, 0.0, 0.0);
				e1 = D3DXVECTOR3(1.0, 0.0, 0.0);
				e2 = D3DXVECTOR3(0.0, 1.0, 0.0);
				e3 = D3DXVECTOR3(0.0, 0.0, 1.0);
			} else if(ret == "obj"){
				mode = MODE_OBJECT_READ;
				//ǂݍ
				file = data[0];
				file.Remove('"');
				scale = 1.0;
				pos = D3DXVECTOR3(0.0, 0.0, 0.0);
				e1 = D3DXVECTOR3(1.0, 0.0, 0.0);
				e2 = D3DXVECTOR3(0.0, 1.0, 0.0);
				e3 = D3DXVECTOR3(0.0, 0.0, 1.0);
			} else if(ret == "pos"){
				pos.x = atof(data[0]);
				pos.y = atof(data[1]);
				pos.z = atof(data[2]);
			} else if(ret == "ex"){
				e1.x = atof(data[0]);
				e1.y = atof(data[1]);
				e1.z = atof(data[2]);
			} else if(ret == "ey"){
				e2.x = atof(data[0]);
				e2.y = atof(data[1]);
				e2.z = atof(data[2]);
			} else if(ret == "ez"){
				e3.x = atof(data[0]);
				e3.y = atof(data[1]);
				e3.z = atof(data[2]);
			} else if(ret == "rot_x"){
				//y𒆐Sɉ]
				D3DXMatrixRotationX(&Rx, atof(data[0]));
				// ]s쐬
			} else if(ret == "rot_y"){
				//y𒆐Sɉ]
				D3DXMatrixRotationY(&Ry, atof(data[0]));
				// ]s쐬
			} else if(ret == "rot_z"){
				//y𒆐Sɉ]
				D3DXMatrixRotationZ(&Rz, atof(data[0]));
				// ]s쐬
			} else if(ret == "scale"){
				scale = atof(data[0]);
			} else if(ret == "light_end"){
				//u
				R = Ry * Rx * Rz;
				D3DXVec3TransformCoord(&e1, &e1, &R);
				D3DXVec3TransformCoord(&e2, &e2, &R);
				D3DXVec3TransformCoord(&e3, &e3, &R);
				m_objloader.load_object(file.GetBuffer(1024), pos, scale * e1, scale * e2, scale * e3, lights);
			} else if(ret == "obj_end"){
				//̂u
				R = Ry * Rx * Rz;
				D3DXVec3TransformCoord(&e1, &e1, &R);
				D3DXVec3TransformCoord(&e2, &e2, &R);
				D3DXVec3TransformCoord(&e3, &e3, &R);
				m_objloader.load_object(file.GetBuffer(1024), pos, scale * e1, scale * e2, scale * e3, ptrianlges);
			};
		};// while

		cam.init_orthogonal();
	};

};

#endif
