// S_renderer_dlgDlg.h : wb_[ t@C
//

#if !defined(AFX_S_RENDERER_DLGDLG_H__132EECE6_CDC0_4F55_8167_4C60F02C4911__INCLUDED_)
#define AFX_S_RENDERER_DLGDLG_H__132EECE6_CDC0_4F55_8167_4C60F02C4911__INCLUDED_

#include "RNG.h"	// ClassView ɂĒǉ܂B
#include "s_ray.h"	// ClassView ɂĒǉ܂B
#include "path_tracer.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "dib.h"
#include "d3dsetup9.h"
#include "obj_loader.h"	// ClassView ɂĒǉ܂B
#include "text_loader.h"	// ClassView ɂĒǉ܂B

/////////////////////////////////////////////////////////////////////////////
// CS_renderer_dlgDlg _CAO

class CS_renderer_dlgDlg : public CDialog
{
// \z
public:
	void write_pfm(LPSTR filename, gray_t & R, gray_t & G, gray_t & B, FLOAT num);
	void draw_frame(CDC *pDC);
	scene_loader m_scene_loader;

	void line(gray_t & img, int x1,int y1,int x2,int y2);

	void two_tangent_vector(const D3DXVECTOR3 &n, D3DXVECTOR3 &bx, D3DXVECTOR3 &by);
	FLOAT Rd(FLOAT alpha, FLOAT A);
	bool find_root_Rd_divide(FLOAT & a, FLOAT &b, FLOAT & aRd, FLOAT &bRd, FLOAT & rd, FLOAT A,  FLOAT epsiron);
	FLOAT find_root_Rd(FLOAT A, FLOAT Rd, FLOAT epsiron = 0.001);

	void CS_renderer_dlgDlg::SetMinMax(D3DXVECTOR3 pt1, D3DXVECTOR3 pt2, D3DXVECTOR2 gMinMaxTable[]);
	void draw_polygon(CDC *pDC, const D3DXVECTOR3 & p1, const D3DXVECTOR3 & p2, const D3DXVECTOR3 & p3);
	obj_loader m_obj_loader;
	RNG rng;
	void construct_scene();
	void gen_materials();
	PathTracer path_tracer;
	Ray ray;
	CS_renderer_dlgDlg(CWnd* pParent = NULL);	// W̃RXgN^
	FLOAT w, h;
	CDIB dib;
	gray_t dR, dG, dB;
	gray_t pR, pG, pB;
	camera cam;
	CPoint click_point, last_point;
	int	   mouse_mode;
#define MOUSEMODE_LEFT	1
#define MOUSEMODE_RIGHT	2

	int triangle_num;

	CD3DSetup9 d3setup;
	CXfile xfile;

	HRESULT read_mesh(LPSTR filename, FLOAT px, FLOAT py, FLOAT pz, FLOAT rot_y, FLOAT scale, Material * mat);

// _CAO f[^
	//{{AFX_DATA(CS_renderer_dlgDlg)
	enum { IDD = IDD_S_RENDERER_DLG_DIALOG };
		// : ̈ʒu ClassWizard ɂăf[^ oǉ܂B
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CS_renderer_dlgDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	materials_t materials;
	Material trans_mat[6], diffuse_mat, diffuse_mat2, light_mat;
	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CS_renderer_dlgDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPathTracing();
	afx_msg void OnObj();
	afx_msg void OnLeft();
	afx_msg void OnRight();
	afx_msg void OnBackword();
	afx_msg void OnFoward();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_S_RENDERER_DLGDLG_H__132EECE6_CDC0_4F55_8167_4C60F02C4911__INCLUDED_)
