//
//  Wavefront Obj`̃t@C̓ǂ݂݃C^[tFCX
//         by g0307 2006.10.9
//
#include "stdafx.h"
#include "obj_loader.h"

//
//  Objt@C̓ǂݍ
//
void obj_loader::load_obj(CDC *pDC, LPSTR filename, ptriangles_t & ptrianlges){

	triangle_num = 0;

	std::ifstream str(filename);

	if(!str.is_open())
		return;

//	D3DXVECTOR3 T(-3.0f, 10.0f, 10.5f); //fish
//	FLOAT scale = 20.0;

//	D3DXVECTOR3 T(-0.3f, 8.0f, 6.5f); //rq
//	FLOAT scale = 16.0;

	D3DXVECTOR3 T(-0.7f, 7.5f, 3.5f); //pu
	FLOAT scale = 16.0;

//	D3DXVECTOR3 T(1.0f, 1.8f, 10.5f);//tpot
//	FLOAT scale = 0.4;

//	D3DXVECTOR3 T(0.8f, 0.2f, 10.0f); //ball
//	FLOAT scale = 2.0;

//	D3DXVECTOR3 T(0.0f, 1.0f, 5.0f); //venus
//	FLOAT scale = 0.017;
//
	CString line(1024), title(1024), param[10], current_mat_name;
	FLOAT x, y, z, u[3], v[3], nx[3], ny[3], nz[3];
	int i, n;
	DWORD pi1, pi2, pi3;
	DWORD ui1, ui2, ui3;
	DWORD ni1, ni2, ni3;
	Material * pCurrentMat = &mat_lib.default_matrial;

	std::vector<D3DXVECTOR3> Vertexes;   // _W
	std::vector<D3DXVECTOR3> Normals;    // @xNg
	std::vector<D3DXVECTOR2> UVs;		 // UVW

	// 
	for(i = 0; i < 10; i++)
		param[i] = CString::CString(1024);

	Vertexes.clear();
	Normals.clear();
	UVs.clear();

	int ln = 0;
	// t@Cǂݍ
	while( !str.eof() ){

		ln++;
		// Psǂ
		str.getline(line.GetBuffer(1024), 1024, '\n');
		// RgƂ͖
		if(line.IsEmpty() || line.GetAt(0) == '#' || line == "")
			continue;
		sscanf(line.GetBuffer(1024), "%s %s %s %s %s", 
			title.GetBuffer(1024),
			param[0].GetBuffer(1024),
			param[1].GetBuffer(1024),
			param[2].GetBuffer(1024),
			param[3].GetBuffer(1024)
			);
		if(title == "v"){
			// _Wl
			x =  atof(param[0]) * scale;
			y = -atof(param[1]) * scale;
			z = -atof(param[2]) * scale;
			Vertexes.push_back(D3DXVECTOR3(x, y, z) + T);
		} else if(title == "vt"){
			// UVWl
			x = atof(param[0]);
			y = atof(param[1]);
			UVs.push_back(D3DXVECTOR2(x, y));
		} else if(title == "vn"){
			// @xNg
			x =  atof(param[0]);
			y = -atof(param[1]);
			z = -atof(param[2]);
			Normals.push_back(D3DXVECTOR3(x, y, z));			
		} else if(title == "f" && pCurrentMat->R->rgb.x >= 0){
			for(n = 0; n < 2 && param[n + 2] != ""; n++){
				// |S
				pi1 = pi2 = pi3 = -1;
				get_indexes_from_str(param[0], param[n + 1], param[n + 2], pi1, pi2, pi3, OBJ_INDEX_POLYGON);
				// UVl
				get_indexes_from_str(param[0], param[n + 1], param[n + 2], ui1, ui2, ui3, OBJ_INDEX_UV);
				// @
				get_indexes_from_str(param[0], param[n + 1], param[n + 2], ni1, ni2, ni3, OBJ_INDEX_NORMAL);
				//**********************************
				//    @}bv摜ɏ
				//**********************************
				gray_t & map_nx = *pCurrentMat->R->map_nx;
				gray_t & map_ny = *pCurrentMat->R->map_ny;
				gray_t & map_nz = *pCurrentMat->R->map_nz;

				FLOAT map_w = pCurrentMat->R->nw, map_h = pCurrentMat->R->nh;
				FLOAT Lu, Lv, Gu, Gv, step = 0.02;
				D3DXVECTOR3 phong_normal;
				//
				// @}bv̏
				//
				if(pCurrentMat->R->fNormalmap)
				draw_trianlge_normal(
						pDC, map_nx, map_ny, map_nz, map_w, map_h, 
						Vertexes[pi1], 
						Vertexes[pi2],
						Vertexes[pi3],
						UVs[ui1] ,
						UVs[ui2] ,
						UVs[ui3] ,
						Normals[ni1],
						Normals[ni2],
						Normals[ni3]
					);
				// vZ
				/*
				for(Lu = 0; Lu <= 1.0 + step; Lu += step){
					for(Lv = 0; Lv <= 1.0 + step; Lv += step){
						Gu = (UVs[ui1].x * (1-Lu)+UVs[ui2].x*Lu)*(1-Lv/(1-Lu))+(UVs[ui3].x*(1-Lu)+UVs[ui2].x*Lu) * Lv/(1-Lu);
						Gv = (UVs[ui1].y * (1-Lu)+UVs[ui2].y*Lu)*(1-Lv/(1-Lu))+(UVs[ui3].y*(1-Lu)+UVs[ui2].y*Lu) * Lv/(1-Lu);
						if(Gv > 0 && Gu > 0 && Gv < 1 && Gu < 1 && (Gv+Gu)<1 ){
							// X[XVF[fBOi@̕ԁj
							phong_normal =
								(Normals[ni1] * (1-Lu)+Normals[ni2]*Lu)*(1-Lv/(1-Lu))+(Normals[ni3]*(1-Lu)+Normals[ni2]*Lu) * Lv/(1-Lu);
							*map_nx.at(Gu * map_w, Gv * map_h) = phong_normal.x;// * 128.0f + 128;
							*map_ny.at(Gu * map_w, Gv * map_h) = phong_normal.y;// * 128.0f + 128;
							*map_nz.at(Gu * map_w, Gv * map_h) = phong_normal.z;// * 128.0f + 128;
							};
					};
				};
				/*
				u[0] = UVs[ui1].x;v[0] = UVs[ui1].y;
				u[1] = UVs[ui2].x;v[1] = UVs[ui2].y;
				u[2] = UVs[ui3].x;v[2] = UVs[ui3].y;
				pDC->MoveTo(u[0] * map_w, v[0] * map_h);
				pDC->LineTo(u[1] * map_w, v[1] * map_h);
				pDC->LineTo(u[2] * map_w, v[2] * map_h);
				pDC->LineTo(u[0] * map_w, v[0] * map_h);
				*/

				D3DXVECTOR3 dp1 = Vertexes[pi1]  - Vertexes[pi2] ;
				D3DXVECTOR3 dp2 = Vertexes[pi1]  - Vertexes[pi3] ;
				FLOAT d1 = D3DXVec3Dot(&dp1, &dp1);
				FLOAT d2 = D3DXVec3Dot(&dp2, &dp2);
				// |S̍쐬
				int vs = Vertexes.size();
				if(
					pi1 >= 0 && pi1 < vs &&
					pi2 >= 0 && pi2 < vs &&
					pi3 >= 0 && pi3 < vs && (d1 < 0.5f && d2 < 0.5f || vs < 1000)){
					if(ui1 != -1 && ni1 != -1){
					ptrianlges.push_back(new Triangle(
						Vertexes[pi1], 
						Vertexes[pi2],
						Vertexes[pi3],
						UVs[ui1],
						UVs[ui2],
						UVs[ui3],
						Normals[ni1],
						Normals[ni2],
						Normals[ni3],
						pCurrentMat));
					} else if(ni1 != -1){
					ptrianlges.push_back(new Triangle(
						Vertexes[pi1], 
						Vertexes[pi2],
						Vertexes[pi3],
						Normals[ni1],
						Normals[ni2],
						Normals[ni3],
						pCurrentMat));
					} else if(ui1 != -1){
					ptrianlges.push_back(new Triangle(
						Vertexes[pi1], 
						Vertexes[pi2],
						Vertexes[pi3],
						UVs[ui1],
						UVs[ui2],
						UVs[ui3],
						pCurrentMat));
					};
					triangle_num++;
				};
				
			}
			
		} else if(title == "g"){
			// O[v
			
		} else if(title == "usemtl"){
			// ގ̕ύX

			pCurrentMat = mat_lib.get_material(param[0].GetBuffer(1024));
			current_mat_name = param[0];

				
			
		} else if(title == "mtllib"){
			// ގCu̓ǂݍ
			mat_lib.load_materials(param[0].GetBuffer(1024));
		}

	};
	//**********************************************************
	//
	//  ㏈
	//
	//**********************************************************

	/*
	// @̂Ȓl
	for(i = 0; i < mat_lib.tex_num; i++){
		mat_lib.fill_normal(mat_lib.tex_images[i].x, 8);
		mat_lib.fill_normal(mat_lib.tex_images[i].y, 8);
		mat_lib.fill_normal(mat_lib.tex_images[i].z, 8);
		char img_file[256];
		sprintf(img_file, "./normal_map_%d.bmp", i);
		write_normalmap(img_file, mat_lib.tex_images[i].x, mat_lib.tex_images[i].y, mat_lib.tex_images[i].z);
	};
	*/


};

bool obj_loader::get_indexes_from_str(CString &p1, CString &p2, CString &p3, DWORD &id1, DWORD &id2, DWORD &id3, DWORD type)
{

	DWORD d[3] = {-1, -1, -1}, du;

	if(!get_line(p1, id1, type))
		return false;

	get_line(p2, id2, type);
	get_line(p3, id3, type);

	id1--;
	id2--;
	id3--;
	return true;
}

bool obj_loader::get_line(CString &str, DWORD &id, int type)
{

	char line[1024];
	memcpy(line, str.GetBuffer(1024), 1024);
	int i;
	DWORD d;

	id = -1;
	bool fNoUV = false;
	for(i = 0; i < 1000;i++){
		if(line[i] == '/' && line[i+1] == '/'){
			fNoUV = true;
		};
		if(line[i] == '/') line[i] = ' ';
	};//i

	if(type == 0){
		sscanf(line, "%d", &id);
	} else if(type == 1 && !fNoUV){
		sscanf(line, "%d %d", &d, &id);
	} else if(type == 2){
		if(fNoUV)
		sscanf(line, "%d %d", &d, &id);
			else
		sscanf(line, "%d %d %d", &d, &d, &id);
	};

	if(id == -1)
		return false;

	return true;

}


//
//
//
//
//  t@C̓ǂݍ
//
void material_lib::load_materials(LPSTR filename){

	std::ifstream str(filename);

	if(!str.is_open())
		return;

	CString line(1024), title(1024), param[10];
	Material tmp_mat, *cur_mat;
	int mat_index = materials.size();
	int i, n;
	FLOAT R, G, B;
	CString texture_file(1024), bump_file(1024), mat_name(1024);

	// 
	for(i = 0; i < 10; i++)
		param[i] = CString::CString(1024);

	int ln = 0;
	// t@Cǂݍ
	while( !str.eof() ){

		ln++;
		// Psǂ
		str.getline(line.GetBuffer(1024), 1024, '\n');
		// RgƂ͖
		if(line.IsEmpty() || line.GetAt(0) == '#' || line == "")
			continue;
		sscanf(line.GetBuffer(1024), "%s %s %s %s %s", 
			title.GetBuffer(1024),
			param[0].GetBuffer(1024),
			param[1].GetBuffer(1024),
			param[2].GetBuffer(1024),
			param[3].GetBuffer(1024)
			);
		if(title == "newmtl"){
			// Vގǉ
			materials.push_back(tmp_mat);
			matnames.push_back(param[0].GetBuffer(1024));
			mat_name = param[0].GetBuffer(1024);
			cur_mat = &materials[mat_index];
			// @obt@m
			mat_index++;
		} else if(title == "Kd"){
			// diffusel
			R = atof(param[0].GetBuffer(1024));
			G = atof(param[1].GetBuffer(1024));
			B = atof(param[2].GetBuffer(1024));
			cur_mat->gen_diffuse_material((Texture *) new Texture(D3DXVECTOR3(R, G, B)));
		} else if(title == "Ks"){
			// diffusel
			R = atof(param[0].GetBuffer(1024));
			G = atof(param[1].GetBuffer(1024));
			B = atof(param[2].GetBuffer(1024));
			cur_mat->set_specular(D3DXVECTOR3(R, G, B));
		} else if(title == "map_Kd"){
			// eNX`̓ǂݍ
			rgb_image *pimg = load_texture_image(param[0].GetBuffer(1024));
			if(pimg){
				cur_mat->R->init_texture(&pimg->r, &pimg->g, &pimg->b, param[0].GetBuffer(1024));
//				cur_mat->R->init_normalmap(&pimg->x, &pimg->y, &pimg->z);
			};

		} else if(title == "map_Bump"){
			// ov}bv̓ǂݍ
			bump_file = param[0].GetBuffer(1024);
			rgb_image *pimg = load_bump_image(param[0].GetBuffer(1024));
			if(pimg){
				cur_mat->R->init_bump(&pimg->g);
//				cur_mat->R->init_normalmap(&pimg->x, &pimg->y, &pimg->z);
			};
		} else if(title == "sss"){

			cur_mat->gen_sss_material(1.3, //skin2
//				NULL
//			,D3DXVECTOR3(0.013f, 0.070f, 0.145f) // sigma_a z skin2
//			,D3DXVECTOR3(1.09f, 1.59f, 1.79f)  // sigma_s U
//		(Texture *) new Texture(D3DXVECTOR3(0.83f, 0.79f, 0.75f))
//		,D3DXVECTOR3(0.0021f, 0.0041f, 0.0071f) // sigma_a z mable
//		,D3DXVECTOR3(2.19f, 2.62f, 3.00f)		// sigma_s U
		(Texture *) new Texture(D3DXVECTOR3(0.63f, 0.44f, 0.34f)) //skin2
		,D3DXVECTOR3(0.013f, 0.070f, 0.145f) // sigma_a z
		,D3DXVECTOR3(1.09f, 1.59f, 1.79f)  // sigma_s U
//		(Texture *) new Texture(D3DXVECTOR3(0.44f, 0.22f, 0.13f)) //skin1
//		,D3DXVECTOR3(0.032f, 0.17f, 0.48f) // sigma_a z
//		,D3DXVECTOR3(0.74f, 0.88f, 1.01f)  // sigma_s U
//		(Texture *) new Texture(D3DXVECTOR3(0.77f, 0.62f, 0.21f))
//		,D3DXVECTOR3(0.0024f, 0.0090f, 0.12f)		// sigma_a z
//		,D3DXVECTOR3(0.68f, 0.70f, 0.55f) // sigma_s U
//		(Texture *) new Texture(D3DXVECTOR3(0.7f, 0.4f, 0.2f))
//		,D3DXVECTOR3(0.001f, 0.001f, 0.00213f)		// sigma_a z
//		,D3DXVECTOR3(0.657f, 0.786f, 0.9f) // sigma_s U
				);

		}
	};

}
//
//  L[ɊւގԂ
//
Material * material_lib::get_material(LPSTR mat_name)
{
	int i;
	
	for(i = 0; i < matnames.size(); i++){
		if(matnames[i] == mat_name)
			return &materials[i];
	};
	//ȂƂ̓ftHgގԂ
	return &default_matrial;
}

material_lib::material_lib()
{
	matnames.clear();
	materials.clear();
	bump_num = tex_num = 0;
	// ftHgގ
	default_matrial.gen_diffuse_material((Texture *) new Texture(D3DXVECTOR3(0.7f, 0.7f, 0.7f)));
}

obj_loader::load_obj()
{
}

//
//  摜eNX`ǂݍ
//
rgb_image * material_lib::load_texture_image(LPSTR filename)
{
	// ɓ摜ǂݍłȂ炻̃|C^Ԃ
	int i;
	for(i = 0; i < tex_num; i++){
		if(tex_images[i].name == filename)
			return &tex_images[i];
	};// i

	CDIB dib;
	if(!dib.read(NULL, filename))
		return NULL;

	rgb_image *ref = &tex_images[tex_num];
	gray_t r, g, b;

	build_albedo_LUT(1.3, LUT);
	dib.decompose3(r, g, b);
	tran2albedo(r, ref->r, 1.3, LUT);
	tran2albedo(g, ref->g, 1.3, LUT);
	tran2albedo(b, ref->b, 1.3, LUT);
//	dib.decompose3(ref->r, ref->g, ref->b);
//	dib.decompose3(ref->x, ref->y, ref->z);
//	init_normalmap(ref->x, ref->y, ref->z, ref->r.width, ref->r.height);
	ref->name = filename;
	tex_num++;

	return ref;
}

void material_lib::tran2albedo(const gray_t &in, gray_t &out, FLOAT eta, FLOAT *lut)
{

	int x, y, w, h;
	FLOAT A, Fdr, alpha, diffuse, exp_alpha, rec_alpha, a, b, rd;

	w = in.width;
	h = in.height;

	out.resize(w, h);

	for(y = 0; y < h; y++){
		for(x = 0; x < w; x++){
		
			alpha = LUT[(int)(*in.at(x, y) * 0.95)];
			// K}␳
//			exp_alpha = powf(alpha, 2.0);
			//
//			*out.at(x, y) = exp_alpha * 255.0f;
			*out.at(x, y) = alpha * 255.0f;

			/*
			// reconstruction
			rec_alpha = int(exp_alpha * 255.0f) / 255.0f;
			rec_alpha = pow(rec_alpha, 1/25.0);

			if(rec_alpha>1.0)rec_alpha=1.0;
			if(rec_alpha<0.0)rec_alpha=0.0;
			a = expf(-sqrtf(3-3*rec_alpha));
			b = expf(-4.0 * A * sqrtf( (1-rec_alpha)/3.0f));
			rd = rec_alpha * a * (1 + b) * 0.5;
			//
			*out.at(x, y) = rd * 255.0f;
			*/
			
		};//x
	};//y


}

//
//  Rd()-Rd = 0𖞂̒Tij[g@j
//
FLOAT material_lib::find_root_Rd(FLOAT A, FLOAT rd, FLOAT epsiron)
{

	int k = 0;
	FLOAT a, b, aRd, bRd, alpha;
	bool fFind = false;
	a = 0;aRd = 0;
	b = 1.0;bRd = 1.0;
	while(k++<100 && !fFind){
		fFind = find_root_Rd_divide(a, b, aRd, bRd, rd, A, epsiron);
	};
	alpha = (a + b) * 0.5;

	/*
	int k = 0;
	FLOAT alpha = 0.9999f;//l
	FLOAT a, b, rd, rdd;
	FLOAT f = sqrtf(3) / 12.0;


	while(k++<300){
		a = expf(-sqrtf(3-3*alpha));
		b = expf(-4.0 * A * sqrtf( (1-alpha) / 3.0f ));
		rd = alpha * a * (1 + b) * 0.5 - Rd;
		if(fabs(rd) < epsiron)
			return alpha;
		
		rdd = (a + a * b) * 0.5 + alpha * f * a * (3 * b + 4 * A * b + 3) / sqrtf(1-alpha);
		// j[g@ɂXV
		alpha = alpha - rd / rdd;
		if(alpha >= 1.0)
			return 1.0f;
	};
	*/


	return alpha;

}

//
// 񕪊@ɂ@
//
bool material_lib::find_root_Rd_divide(FLOAT & a, FLOAT &b, FLOAT & aRd, FLOAT &bRd, FLOAT & rd, FLOAT A, FLOAT epsiron)
{
	FLOAT c = (a + b) * 0.5;
	FLOAT cRd;

	cRd = c * expf(-sqrtf(3-3*c)) * (1 + expf(-4.0 * A * sqrtf( (1-c)/3.0f))) * 0.5;

	if(aRd < rd && rd < cRd - epsiron){
		bRd = cRd;
		b = c;
		return false;
	}
	if(cRd < rd + epsiron && rd <= bRd){
		aRd = cRd;
		a = c;
		return false;
	}

	return true;
}

//
//  摜eNX`ǂݍ
//
rgb_image * material_lib::load_bump_image(LPSTR filename)
{
	// ɓ摜ǂݍłȂ炻̃|C^Ԃ
	int i;
	for(i = 0; i < bump_num; i++){
		if(bump_images[i].name == filename)
			return &bump_images[i];
	};// i

	CDIB dib;
	if(!dib.read(NULL, filename))
		return NULL;

	rgb_image *ref = &bump_images[bump_num];
	dib.decompose3(ref->g, ref->g, ref->g);
	ref->name = filename;
	bump_num++;

	return ref;
}

void obj_loader::draw_trianlge_normal(CDC *pDC,gray_t & map_nx, gray_t & map_ny, gray_t & map_nz, 
									  int map_w, int map_h, 
		const D3DXVECTOR3 & x1, const D3DXVECTOR3 & x2, const D3DXVECTOR3 & x3, 
		const D3DXVECTOR2 & uv1, const D3DXVECTOR2 & uv2, const D3DXVECTOR2 & uv3, 
		const D3DXVECTOR3 & n1, const D3DXVECTOR3 & n2, const D3DXVECTOR3 & n3 
)
{

	D3DXVECTOR2 p1, p2, p3;
	D3DXVECTOR3 min_p, max_p;

	p1.x = int(floor(uv1.x * map_w));
	p1.y = int(floor(uv1.y * map_h));
	p2.x = int(floor(uv2.x * map_w));
	p2.y = int(floor(uv2.y * map_h));
	p3.x = int(floor(uv3.x * map_w));
	p3.y = int(floor(uv3.y * map_h));
	int i;

	//oEfBO{bNX
	min_p.x = min(p1.x, min(p2.x, p3.x));
	min_p.y = min(p1.y, min(p2.y, p3.y));
	max_p.x = max(p1.x, max(p2.x, p3.x));
	max_p.y = max(p1.y, max(p2.y, p3.y));
	D3DXVECTOR2 gMinMaxTable[3000];

	FLOAT x, y;
	// e[ȕ
	for(y = min_p.y; y <= max_p.y; y++){
		gMinMaxTable[int(y)].x =  999999;	// ŏlƂ32767ݒ
		gMinMaxTable[int(y)].y = -999999;	// őlƂ-32768ݒ
	}
	
	// Min-Maxe[uݒ
	SetMinMax(p1, p2, gMinMaxTable);
	SetMinMax(p2, p3, gMinMaxTable);
	SetMinMax(p3, p1, gMinMaxTable);

	FLOAT min_x, max_x, xh;
	D3DXVECTOR3 a, b, c, d, z, min_z, max_z;
	for(i = 0; i < 3; i++){
		a[i] = (p2.y  -   p1.y) *(n3[i] - n1[i]) - (p3.y  - p1.y)  * (n2[i] - n1[i]);
		b[i] = (n2[i] -   n1[i])*(p3.x  - p1.x)  - (n3[i] - n1[i]) * (p2.x  - p1.x);
		c[i] = (p2.x  -   p1.x) *(p3.y  - p1.y)  - (p3.x  - p1.x)  * (p2.y  - p1.y);
		d[i] = -p1.x * a[i] - p1.y * b[i] - n1[i] * c[i];
	};
	// C̕`
	if(max_p.y > map_h - 1)max_p.y = map_h - 1;
	if(min_p.y < 0) min_p.y = 0;

	if(max_p.y - min_p.y > 0){
	for(y = min_p.y; y <= max_p.y; y++){
		min_x = max(gMinMaxTable[int(y)].x, 0);
		max_x = min(gMinMaxTable[int(y)].y, map_w);

		xh = max_x - min_x;
		if(xh <= 0)continue;

		for(i = 0; i < 3; i++){
			if(fabsf(c[i]) > 0.0001f){
			min_z[i] = -(d[i] + a[i] * min_x + b[i] * y) * (1/c[i]);
			max_z[i] = -(d[i] + a[i] * max_x + b[i] * y) * (1/c[i]);
			} else {
			min_z[i] = -(d[i] + a[i] * min_x + b[i] * y);
			max_z[i] = -(d[i] + a[i] * max_x + b[i] * y);
			};
		}
			for(x = min_x; x <= max_x; x++){
				z = (min_z + (max_z - min_z) * ((x - min_x) / xh));
				if(1||*map_nx.at(x, y) < -10){
				D3DXVec3Normalize(&z, &z);
				pDC->FillSolidRect(x,  y, 1, 1, RGB(z.x * 128+ 128, z.y * 128+ 128, z.z * 128+ 128));
				/*
				*map_nx.at(x, y) = z.x * 128 + 128;
				*map_ny.at(x, y) = z.y * 128 + 128;
				*map_nz.at(x, y) = z.z * 128 + 128;
				*/
				*map_nx.at(x, y) = z.x;
				*map_ny.at(x, y) = z.y;
				*map_nz.at(x, y) = z.z;
				};
			};//x
	};//y
	}
	
}

void obj_loader::SetMinMax(D3DXVECTOR2 pt1, D3DXVECTOR2 pt2, D3DXVECTOR2 gMinMaxTable[]){
	int	dx, dy, s, step;
	FLOAT step_z;
	
	dx = pt1.x -pt2.x;	if(dx < 0)	dx = -dx;
	dy = pt1.y -pt2.y;	if(dy < 0)	dy = -dy;
	
	if(dx > dy){
		if(pt1.x > pt2.x){
			step = (pt1.y > pt2.y)? 1: -1;
			std::swap(pt1.x, pt2.x);
			pt1.y = pt2.y;
		}else{
			step = (pt1.y < pt2.y)? 1: -1;
		}
		
		if(pt1.y > 0 && pt1.y < 2500){
			if(pt1.x < gMinMaxTable[int(pt1.y)].x){
				gMinMaxTable[int(pt1.y)].x = pt1.x;
			};
			if(pt1.x > gMinMaxTable[int(pt1.y)].y){
				gMinMaxTable[int(pt1.y)].y = pt1.x;
			};
		}
		
		s = dx >>1;
		while(++pt1.x <= pt2.x){
			if((s -= dy) < 0){
				s += dx;
				pt1.y += step;
			}
			
			if(pt1.y > 0 && pt1.y < 2500){
			if(pt1.x < gMinMaxTable[int(pt1.y)].x)
				gMinMaxTable[int(pt1.y)].x = pt1.x;
			if(pt1.x > gMinMaxTable[int(pt1.y)].y)
				gMinMaxTable[int(pt1.y)].y = pt1.x;
			}
		}
	}else{
		if(pt1.y > pt2.y){
			step = (pt1.x > pt2.x)? 1: -1;
			std::swap(pt1.y, pt2.y);
			pt1.x = pt2.x;
		}else{
			step = (pt1.x < pt2.x)? 1: -1;
		}
		
		if(pt1.y > 0 && pt1.y < 2500){
			if(pt1.x < gMinMaxTable[int(pt1.y)].x)
				gMinMaxTable[int(pt1.y)].x = pt1.x;
			if(pt1.x > gMinMaxTable[int(pt1.y)].y)
				gMinMaxTable[int(pt1.y)].y = pt1.x;
		}
		
		s = dy >>1;
		while(++pt1.y <= pt2.y){
			if((s -= dx) < 0){
				s += dy;
				pt1.x += step;
			}
			
			if(pt1.y > 0 && pt1.y < 2500){
			if(pt1.x < gMinMaxTable[int(pt1.y)].x)
				gMinMaxTable[int(pt1.y)].x = pt1.x;
			if(pt1.x > gMinMaxTable[int(pt1.y)].y)
				gMinMaxTable[int(pt1.y)].y = pt1.x;
			}
		}
	}
}


void material_lib::init_normalmap(gray_t &nx, gray_t &ny, gray_t &nz, int nw, int nh)
{

	int x, y;
	nx.resize(nw, nh);
	ny.resize(nw, nh);
	nz.resize(nw, nh);
	
	for(y = 0; y < nh; y++){
		for(x = 0; x < nw; x++){
			*nx.at(x, y) = -100;
			*ny.at(x, y) = -100;
			*nz.at(x, y) = -100;
		};//x
	};//y


}

void material_lib::fill_normal(gray_t &img, int mask)
{
	int x, y, mx, my, sx, sy, w, h;
	gray_t tmp;
	FLOAT mean, c;
	w = img.width;
	h = img.height;
	tmp = img;
	
	for(y = 0; y < h; y++){
		for(x = 0; x < w; x++){
			// ͂l͕ԂĖ߂
			if(*img.at(x, y) < -10){
				c = mean = 0;
				for(my = -mask; my <= mask; my++){
					for(mx = -mask; mx <= mask; mx++){
						sx = x + mx;if(sx < 0)sx=-sx;else if(sx >= w)sx = 2 * w - sx - 1;
						sy = y + my;if(sy < 0)sy=-sy;else if(sy >= h)sy = 2 * h - sy - 1;
						if(*img.at(sx, sy) > -10){
							mean = mean + *img.at(sx, sy);
							c++;
						};
					};//mx
				};//my
				if(c > 0){
					*tmp.at(x, y) = mean / c;
				} else
					*tmp.at(x, y) = 0;
			} else {
				*tmp.at(x, y) = *img.at(x, y);
			};
		};//x
	};//y

	img = tmp;


}

void obj_loader::write_normalmap(LPSTR filename, gray_t &nx, gray_t &ny, gray_t &nz)
{

	int x, y, w, h;
	w = nx.width;
	h = ny.height;
	CDIB dib;
	gray_t dx, dy, dz;
	dib.resize(w, h);
	dib.decompose3(dx, dy, dz);
	for(y = 0; y < h; y++){
		for(x = 0; x < w; x++){
			*dx.at(x, y) = *nx.at(x, y) * 128 + 128;
			*dy.at(x, y) = *ny.at(x, y) * 128 + 128;
			*dz.at(x, y) = *nz.at(x, y) * 128 + 128;			
		};//x
	};//y
	dib.compose3(dx, dy, dz);
	dib.write(filename);


}


void material_lib::build_albedo_LUT(FLOAT eta, FLOAT *lut)
{

	FLOAT A, Fdr;
	
	Fdr = -1.4399f / (eta*eta) + 0.7099f /eta + 0.6681f + 0.0636f * eta;
	A = (1 + Fdr) / (1- Fdr);
	
	int i;
	for(i = 0; i < 255;i++){
		lut[i] = find_root_Rd(A, (FLOAT)i / 255.0, 0.00001);
	};

}
